/**
 * @file mocap_relay_node.h
 * @brief Node to simulate mocap generated by AirSim
 * @author Parker Lusk <plusk@mit.edu>
 * @date 21 March 2020
 */

#pragma once

#include <ros/ros.h>

#include <tf2_ros/transform_broadcaster.h>
#include <tf2_geometry_msgs/tf2_geometry_msgs.h>

#include <nav_msgs/Odometry.h>
#include <geometry_msgs/PoseStamped.h>
#include <geometry_msgs/TwistStamped.h>
#include <visualization_msgs/Marker.h>

namespace acl {
namespace snap_airsim {

  class MocapRelay
  {
  public:
    MocapRelay(const ros::NodeHandle& nh, const ros::NodeHandle& nhp);
    ~MocapRelay() = default;
    
  private:
    ros::NodeHandle nh_, nhp_;
    ros::Subscriber sub_odom_;
    ros::Publisher pub_pose_, pub_twist_, pub_vizmesh_;
    tf2_ros::TransformBroadcaster br_;

    /// \brief Parameters
    std::string name_; ///< name of the simulated vehicle
    std::string mocap_parent_frame_; ///< pose w.r.t what?
    bool mocap_tf_broadcast_; ///< should we broadcast UAV pose on tf tree?
    bool viz_mesh_; ///< should we publish a mesh marker for rviz
    std::string mesh_uri_; ///< path of mesh
    double mesh_scale_; ///< scaling on mesh visualization
    double imu_dt_; ///< the simulation is driven by IMU measurements
    double mocap_dt_; ///< period at which to broadcast simulated mocap
    double mass_; ///< mass [kg] of vehicle for IMU model

    void odomCb(const nav_msgs::OdometryConstPtr& msg);

    geometry_msgs::Pose toENUPose(const geometry_msgs::Pose& msg);
  };

} // ns snap_airsim
} // ns acl
